///////////////////////////////////////////////////////////////
//TreeView.cpp
//tH_ꗗ\ - CTreeView

///////////////////////////////////////////////////////////////
//INCLUDE
#include "GSFinder.h"
#include "TreeView2.h"

///////////////////////////////////////////////////////////////
#define ID_TREEVIEW			1

///////////////////////////////////////////////////////////////
LRESULT CALLBACK TreeViewProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_KEYUP:
		if (g_MainWnd.m_TreeView.m_bThroughKeyup)
		{
			g_MainWnd.m_TreeView.m_bThroughKeyup = FALSE;
			return 0;
		}
		switch (wParam)
		{
		case VK_PROCESSKEY:
			return 0;

		case VK_BACK:
			if (TreeView_GetSelection(hWnd) == g_MainWnd.m_TreeView.m_hRootItem)
				SetFocus(g_MainWnd.m_ListView.m_hWnd);
			else
				g_MainWnd.m_TreeView.OnViewUpFolder();
			return 0;

		case VK_HYPHEN:
			//tL[[-]eL[[-]ɑ}ւ
			wParam = VK_SUBTRACT;
			break;

		case VK_APOSTROPHE:
			//tL[[Shift]{[:]eL[[*]ɑ}ւ
			if (GetKeyState(VK_SHIFT) & 0x8000)
				wParam = VK_MULTIPLY;
			break;

		case VK_SEMICOLON:
			//tL[[Shift]{[;]eL[[+]ɑ}ւ
			if (GetKeyState(VK_SHIFT) & 0x8000)
				wParam = VK_ADD;
			break;

		default:
			break;
		}
		break;

	case WM_KEYDOWN:
		if (g_MainWnd.m_TreeView.m_bOnComposition)
		{
			g_MainWnd.m_TreeView.m_bThroughKeyup = TRUE;
			return 0;
		}
		switch (wParam)
		{
		case VK_PROCESSKEY:
			return 0;

		case VK_BACK:
			return 0;

		case VK_HYPHEN:
			//tL[[-]eL[[-]ɑ}ւ
			wParam = VK_SUBTRACT;
			break;

		case VK_APOSTROPHE:
			//tL[[Shift]{[:]eL[[*]ɑ}ւ
			if (GetKeyState(VK_SHIFT) & 0x8000)
				wParam = VK_MULTIPLY;
			break;

		case VK_SEMICOLON:
			//tL[[Shift]{[;]eL[[+]ɑ}ւ
			if (GetKeyState(VK_SHIFT) & 0x8000)
				wParam = VK_ADD;
			break;

		case VK_HOME://HOMEL[
			g_MainWnd.m_ListView.OnGoBack();
			return 0;

		case VK_END://ENDL[
			g_MainWnd.m_ListView.OnGoFront();
			return 0;

		case VK_UP:
			if (TreeView_GetSelection(hWnd) == g_MainWnd.m_TreeView.m_hRootItem)
			{
				if (g_MainWnd.m_bEdgeLoop)
				{
					TreeView_SelectItem(hWnd, g_MainWnd.m_TreeView.m_hSearchItem);
					return 0;
				}
			}
			break;

		case VK_DOWN:
			if (TreeView_GetSelection(hWnd) == g_MainWnd.m_TreeView.m_hSearchItem)
			{
				if (g_MainWnd.m_bEdgeLoop)
				{
					TreeView_SelectItem(hWnd, g_MainWnd.m_TreeView.m_hRootItem);
					return 0;
				}
			}
			break;

		default:
			break;
		}
		break;

	case WM_CHAR:
		switch (wParam)
		{
		case VK_RETURN:
		case VK_BACK:
			return 0;

		default:
			break;
		}
		break;

	case WM_SETFOCUS:
		g_MainWnd.m_CmdBands.SetModeFocusMove(TRUE);
		break;

	case WM_KILLFOCUS:
		g_MainWnd.m_CmdBands.SetModeFocusMove(FALSE);
		break;

	case WM_LBUTTONDOWN:	//^bvJn
		g_MainWnd.m_TreeView.OnTapHoldBegin((DWORD)lParam);
		break;

	case WM_MOUSEWHEEL:
		//EMONEXN[zC[Ή
		if (GET_WHEEL_DELTA_WPARAM(wParam) < 0)
		{
			keybd_event(VK_DOWN, 0x3D, 0, 0);
			keybd_event(VK_DOWN, 0x3D, KEYEVENTF_KEYUP, 0);
		}
		else if (GET_WHEEL_DELTA_WPARAM(wParam) > 0)
		{
			keybd_event(VK_UP, 0x3E, 0, 0);
			keybd_event(VK_UP, 0x3E, KEYEVENTF_KEYUP, 0);
		}
		return 0;

	//IME͏Ԃ̎擾
	case WM_IME_STARTCOMPOSITION:
		g_MainWnd.m_TreeView.m_bOnComposition = TRUE;
		break;
	case WM_IME_ENDCOMPOSITION:
		g_MainWnd.m_TreeView.m_bOnComposition = FALSE;
		break;

	default:
		break;
	}

	return CallWindowProc((WNDPROC)GetWindowLong(hWnd, GWL_USERDATA), hWnd, message, wParam, lParam);
}

///////////////////////////////////////////////////////////////
CTreeView::CTreeView()
{
	m_hImageList = NULL;
	m_bEditing = FALSE;
	m_hRootItem = NULL;
	m_bLoadReq = TRUE;
	m_bTimer = FALSE;
	m_bPressAndHoldCorrect = FALSE;
	m_bOnComposition = FALSE;
	m_bThroughKeyup = FALSE;
}

///////////////////////////////////////////////////////////////
CTreeView::~CTreeView()
{
}

///////////////////////////////////////////////////////////////
void CTreeView::Init(HWND hwndParent)
{
	DWORD dwStyle = WS_TABSTOP | WS_VISIBLE | WS_CHILD | TVS_EDITLABELS |
				TVS_HASBUTTONS | TVS_HASLINES | TVS_SHOWSELALWAYS | WS_BORDER;
	DWORD dwExStyle = 0;

	m_hWnd = CreateWindowEx(dwExStyle,
							WC_TREEVIEW,
							NULL, dwStyle, 0, 0, 0, 0,
							hwndParent, (HMENU)ID_TREEVIEW,
							g_hInst, NULL);

	SetWindowLong(m_hWnd, GWL_USERDATA, GetWindowLong(m_hWnd, GWL_WNDPROC));
	SetWindowLong(m_hWnd, GWL_WNDPROC, (DWORD)TreeViewProc);

	InitImageList();
	LoadFolderTree();
}

///////////////////////////////////////////////////////////////
void CTreeView::Destroy()
{
	ImageList_Destroy(m_hImageList);
	//DestroyWindow(m_hWnd);	//(eEChEDestroyWindowőp)
}

///////////////////////////////////////////////////////////////
void CTreeView::TreeExpand(HWND hTree, HTREEITEM hItem, BOOL bDelete)
{
	if (bDelete)
	{
		//c[̎qm[hSč폜
		HTREEITEM hChild = TreeView_GetChild(hTree, hItem);
		while (hChild)
		{
			HTREEITEM hNext = TreeView_GetNextItem(hTree, hChild, TVGN_NEXT);
			TreeView_DeleteItem(hTree, hChild);
			hChild = hNext;
		}
	}

	//qm[h̍Ď擾
	TCHAR szKey[MAX_PATH];
	//1.tH_擾
	GetTree(hItem, szKey);
	//2.qc[񋓂
	EnumChildren(hItem, szKey);
}

///////////////////////////////////////////////////////////////
void CTreeView::LoadChildFolder(HTREEITEM hParent, LPCTSTR szPath)
{
	WIN32_FIND_DATA finddata;
	TCHAR szTemp[MAX_PATH];
	HTREEITEM hTreeItem;
	_stprintf(szTemp, _T("%s\\*.*"), szPath);

	HANDLE hFind = FindFirstFile(szTemp, &finddata);
	if (hFind != INVALID_HANDLE_VALUE)
	{
		BOOL bRet = TRUE;
		do{
			if (finddata.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
			{
				TVINSERTSTRUCT tvis;
				tvis.hParent = hParent;
				tvis.hInsertAfter = TVI_SORT;
				tvis.item.mask = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE;
				tvis.item.pszText = finddata.cFileName;
				tvis.item.iImage = 1;
				tvis.item.iSelectedImage = 1;
				hTreeItem = TreeView_InsertItem(m_hWnd, &tvis);
				_stprintf(szTemp, _T("%s\\%s"), szPath, finddata.cFileName);
				LoadChildFolder(hTreeItem, szTemp);
			}
		}while (FindNextFile(hFind, &finddata));
		FindClose(hFind);
	}

	TreeView_SortChildren(m_hWnd, hParent, 0);
}

///////////////////////////////////////////////////////////////
void CTreeView::SetCurrentFolder(LPCTSTR lpszPath, BOOL bUpdate, BOOL bSelect)
{
	m_bLoadReq = FALSE;

	//fBNgw̏ꍇ
	if (IsSearchFolder(lpszPath))
	{
		//[gWJ
		TreeView_Expand(m_hWnd, m_hRootItem, TVE_EXPAND);

		//ACeI
		TreeView_SelectItem(m_hWnd, m_hSearchItem);
		m_bLoadReq = TRUE;
		return;
	}

	KillTimer(NULL, ID_TIMER_TVSELECTED);
	LPCTSTR lpszStart = _tcschr(lpszPath, _T('\\'));

	//Jnm[h[gɐݒ
	HTREEITEM hSelectItem = m_hRootItem;
	HTREEITEM hParent = m_hRootItem;

	//[gWJ
	TreeView_Expand(m_hWnd, hParent, TVE_EXPAND);

	//ACeȂȂ܂ŌJԂ
	while (lpszStart)
	{
		//fBNgo
		TCHAR szName[MAX_PATH] = _T("");
		LPCTSTR lpszEnd = _tcschr(lpszStart + 1, _T('\\'));
		if (lpszEnd)
		{
			int len = lpszEnd - (lpszStart + 1);
			_tcsncpy(szName, ++lpszStart, len);
			szName[len] = 0;
		}
		else
			_tcscpy(szName, ++lpszStart);

		//qm[h擾
		HTREEITEM hChild = TreeView_GetChild(m_hWnd, hParent);
		while (hChild)
		{
			//qm[h̃ACe擾
			TCHAR szChildName[MAX_PATH] = _T("");
			TVITEM tvi;
			tvi.mask = TVIF_TEXT | TVIF_HANDLE;
			tvi.pszText = szChildName;
			tvi.cchTextMax = MAX_PATH;
			tvi.hItem = hChild;
			TreeView_GetItem(m_hWnd, &tvi);
			
			//Ώۂ̃fBNg̏ꍇ
			if (_tcsicmp(szName, szChildName) == 0)
			{
				hSelectItem = hParent = hChild;
				lpszStart = _tcschr(lpszStart, _T('\\'));
				if (lpszStart)
				{
					//qm[hWJ
					TreeView_Expand(m_hWnd, hParent, TVE_EXPAND);
				}
				break;
			}

			hChild = TreeView_GetNextItem(m_hWnd, hChild, TVGN_NEXT);
		
		}

		if (!hChild)
			break;
	}

	if (bUpdate)
	{
		//m[h̏Ԃ擾
		TVITEM tvi;
		tvi.mask = TVIF_CHILDREN | TVIF_STATE | TVIF_HANDLE;
		tvi.hItem = hParent;
		tvi.cChildren = 0;
		TreeView_GetItem(m_hWnd, &tvi);

		//XVO̎qm[h擾
		HTREEITEM hChild = TreeView_GetChild(m_hWnd, hParent);

		//擪m[hXV(쐬Ȃ)
		TreeExpand(m_hWnd, hParent);

		//XVOɎqm[hAm[hWJĂꍇ
		if (hChild && (tvi.state&TVIS_EXPANDED))
		{
			//m[hJ
			TreeView_Expand(m_hWnd, hParent, TVE_EXPAND);
		}
		else
		{
			//m[h
			TreeView_Expand(m_hWnd, hParent, TVE_COLLAPSE);
		}
	}

	//ACeI
	if (bSelect)
		TreeView_SelectItem(m_hWnd, hSelectItem);

	m_bLoadReq = TRUE;
}

///////////////////////////////////////////////////////////////
void CTreeView::LoadFolderTree()
{
	m_bLoadReq = FALSE;

	//HCURSOR hCursor = SetCursor(LoadCursor(NULL, IDC_WAIT));
	HWND hwndPrev = GetFocus();
	ShowWindow(m_hWnd, SW_HIDE);
	
	TreeView_DeleteAllItems(m_hWnd);

	TVINSERTSTRUCT tvis;
	tvis.hParent = NULL;
	tvis.hInsertAfter = TVI_SORT;
	tvis.item.mask = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_CHILDREN;
	tvis.item.pszText = (LPTSTR)GetRootName();
	tvis.item.iImage = 0;
	tvis.item.iSelectedImage = 0;
	tvis.item.cChildren = 1;
	HTREEITEM hRoot = TreeView_InsertItem(m_hWnd, &tvis);
	//LoadChildFolder(hRoot, _T(""));
	m_hRootItem = hRoot;
	TreeView_Expand(m_hWnd, hRoot, TVE_EXPAND);

	//m_hRootItem = hRoot;

	//SetCursor(hCursor);

	//ʃtH_쐬
	LoadSeachFolderRoot();

	m_bLoadReq = TRUE;

	ShowWindow(m_hWnd, SW_SHOW);
	SetFocus(hwndPrev);
}

//////////////////////////////////////////////////////////////
void CTreeView::LoadSeachFolderRoot()
{
	TVINSERTSTRUCT tvis;
	tvis.hParent = NULL;
	tvis.hInsertAfter = TVI_LAST;
	tvis.item.mask = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_CHILDREN;
	tvis.item.pszText = GetResourceString(IDS_SEARCH_FOLDER_NAME);
	tvis.item.iImage = 7;
	tvis.item.iSelectedImage = 7;
	tvis.item.cChildren = 0;
	m_hSearchItem = TreeView_InsertItem(m_hWnd, &tvis);
}

///////////////////////////////////////////////////////////////
void CTreeView::InitImageList()
{
	m_bLoadReq = FALSE;
	TreeView_DeleteAllItems(m_hWnd);
	TreeView_SetImageList(m_hWnd, NULL, TVSIL_NORMAL);
	ImageList_Destroy(m_hImageList);

	if (g_MainWnd.m_bHighRresolutionMode)
	{
		if (g_MainWnd.m_bTouchUI)
		{
			//nC][hŏk݂Xy[XL
			SendMessage(m_hWnd, TVM_SETITEMSPACING, 0, (int)(20.0/g_MainWnd.m_fpHighResolutionScale));
			SendMessage(m_hWnd, TVM_SETINDENT, 0, (int)(20.0/g_MainWnd.m_fpHighResolutionScale));
		}
		else
		{
			//nC][hŊԉтXy[Xk߂
			SendMessage(m_hWnd, TVM_SETITEMSPACING, 0, 0);
			SendMessage(m_hWnd, TVM_SETINDENT, 0, 0);
		}
	}

	//ImageList쐬
	HICON hIcon;
	if (g_MainWnd.m_bHighRresolutionMode || !g_MainWnd.m_bHighDpiHardware)
	{
		m_hImageList = ImageList_Create((int)((float)GetSystemMetrics(SM_CXSMICON)/g_MainWnd.m_fpHighResolutionScale),
			(int)((float)GetSystemMetrics(SM_CYSMICON)/g_MainWnd.m_fpHighResolutionScale), ILC_COLOR | ILC_MASK, 1, 1);
		AddRootIcon(m_hImageList);
		hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_FOLDER_S);
		ImageList_AddIcon(m_hImageList, hIcon);
		DestroyIcon(hIcon);
		hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_FOLDERO_S);
		ImageList_AddIcon(m_hImageList, hIcon);
		DestroyIcon(hIcon);
		hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_TEMP_S);
		ImageList_AddIcon(m_hImageList, hIcon);
		DestroyIcon(hIcon);
		hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_MYDOCUMENTS_S);
		ImageList_AddIcon(m_hImageList, hIcon);
		DestroyIcon(hIcon);
		hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_START_S);
		ImageList_AddIcon(m_hImageList, hIcon);
		DestroyIcon(hIcon);
		hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_NETFOLDER_S);
		ImageList_AddIcon(m_hImageList, hIcon);
		DestroyIcon(hIcon);
		hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_SEARCH_S);
		ImageList_AddIcon(m_hImageList, hIcon);
		DestroyIcon(hIcon);
	}
	else
	{
		m_hImageList = ImageList_Create(GetSystemMetrics(SM_CXSMICON), GetSystemMetrics(SM_CYSMICON), ILC_COLOR | ILC_MASK, 1, 1);
		AddRootIcon(m_hImageList);
		if (g_MainWnd.m_bIsSmartphone && !g_MainWnd.m_bDisableResizeSpIcon)
		{
			hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_FOLDER_M);
			MyAddResizeSpIcon(m_hImageList, g_MainWnd.m_hWnd, hIcon, FALSE);
			DestroyIcon(hIcon);
			hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_FOLDERO_M);
			MyAddResizeSpIcon(m_hImageList, g_MainWnd.m_hWnd, hIcon, FALSE);
			DestroyIcon(hIcon);
			hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_TEMP_M);
			MyAddResizeSpIcon(m_hImageList, g_MainWnd.m_hWnd, hIcon, FALSE);
			DestroyIcon(hIcon);
			hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_MYDOCUMENTS_M);
			MyAddResizeSpIcon(m_hImageList, g_MainWnd.m_hWnd, hIcon, FALSE);
			DestroyIcon(hIcon);
			hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_START_M);
			MyAddResizeSpIcon(m_hImageList, g_MainWnd.m_hWnd, hIcon, FALSE);
			DestroyIcon(hIcon);
			hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_NETFOLDER_M);
			MyAddResizeSpIcon(m_hImageList, g_MainWnd.m_hWnd, hIcon, FALSE);
			DestroyIcon(hIcon);
			hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_SEARCH_M);
			MyAddResizeSpIcon(m_hImageList, g_MainWnd.m_hWnd, hIcon, FALSE);
			DestroyIcon(hIcon);
		}
		else
		{
			hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_FOLDER_M);
			ImageList_AddIcon(m_hImageList, hIcon);
			DestroyIcon(hIcon);
			hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_FOLDERO_M);
			ImageList_AddIcon(m_hImageList, hIcon);
			DestroyIcon(hIcon);
			hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_TEMP_M);
			ImageList_AddIcon(m_hImageList, hIcon);
			DestroyIcon(hIcon);
			hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_MYDOCUMENTS_M);
			ImageList_AddIcon(m_hImageList, hIcon);
			DestroyIcon(hIcon);
			hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_START_M);
			ImageList_AddIcon(m_hImageList, hIcon);
			DestroyIcon(hIcon);
			hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_NETFOLDER_M);
			ImageList_AddIcon(m_hImageList, hIcon);
			DestroyIcon(hIcon);
			hIcon = LoadIcon(g_hInst, (LPCTSTR)IDI_SEARCH_M);
			ImageList_AddIcon(m_hImageList, hIcon);
			DestroyIcon(hIcon);
		}
	}
	TreeView_SetImageList(m_hWnd, m_hImageList, TVSIL_NORMAL);
	m_bLoadReq = TRUE;
}

///////////////////////////////////////////////////////////////
void CTreeView::SetCurrentFolder()
{
	TCHAR szPath[MAX_PATH] = _T("");
	TCHAR szTemp[MAX_PATH] = _T("");
	TCHAR szName[MAX_PATH] = _T("");
	
	HTREEITEM hTreeItem = TreeView_GetSelection(m_hWnd);
	TVITEM tvi;
	tvi.mask = TVIF_TEXT | TVIF_HANDLE;
	tvi.pszText = szName;
	tvi.cchTextMax = MAX_PATH;
	tvi.hItem = hTreeItem;
	TreeView_GetItem(m_hWnd, &tvi);
	if (_tcscmp(szName, GetRootName()) != 0)
	{
		_tcscpy(szPath, szName);
		hTreeItem = TreeView_GetParent(m_hWnd, hTreeItem);
		while (hTreeItem)
		{
			tvi.hItem = hTreeItem;
			TreeView_GetItem(m_hWnd, &tvi);
			if (_tcscmp(szName, GetRootName()) != 0)
				_stprintf(szTemp, _T("%s\\%s"), szName, szPath);
			else
				_stprintf(szTemp, _T("\\%s"), szPath);
			_tcscpy(szPath, szTemp);
			hTreeItem = TreeView_GetParent(m_hWnd, hTreeItem);
		}
		
		_tcscpy(szTemp, szPath);
	}
	else
	{
		_tcscpy(szTemp, _T(""));
	}
	
	g_MainWnd.m_ListView.LoadFolderItem(szTemp, FALSE);
}

////////////////////////////////////////////////////////////////
void CTreeView::GetCurrentFolder(LPTSTR lpszPath)
{
	TCHAR szPath[MAX_PATH] = _T("");
	TCHAR szTemp[MAX_PATH] = _T("");
	TCHAR szName[MAX_PATH] = _T("");
	
	HTREEITEM hTreeItem = TreeView_GetSelection(m_hWnd);
	TVITEM tvi;
	tvi.mask = TVIF_TEXT | TVIF_HANDLE;
	tvi.pszText = szName;
	tvi.cchTextMax = MAX_PATH;
	tvi.hItem = hTreeItem;
	TreeView_GetItem(m_hWnd, &tvi);
	if (_tcscmp(szName, GetRootName()) != 0)
	{
		_tcscpy(szPath, szName);
		hTreeItem = TreeView_GetParent(m_hWnd, hTreeItem);
		while (hTreeItem)
		{
			tvi.hItem = hTreeItem;
			TreeView_GetItem(m_hWnd, &tvi);
			if (_tcscmp(szName, GetRootName()) != 0)
				_stprintf(szTemp, _T("%s\\%s"), szName, szPath);
			else
				_stprintf(szTemp, _T("\\%s"), szPath);
			_tcscpy(szPath, szTemp);
			hTreeItem = TreeView_GetParent(m_hWnd, hTreeItem);
		}
		
		_tcscpy(szTemp, szPath);
	}
	else
	{
		//_tcscpy(szTemp, _T(""));
		szTemp[0] = _T('\0');
	}
	
	_tcscpy(m_szCurrentFolder, szTemp);
	if (lpszPath) _tcscpy(lpszPath, szTemp);
}
////////////////////////////////////////////////////////////////
void CTreeView::OnKeydown(HWND hwnd, LPNMTVKEYDOWN lpnkd)
{
	if (m_bEditing)
		return;

	if (g_bDraging)
	{
		if (lpnkd->wVKey == VK_ESCAPE)
		{
			g_MainWnd.OnDropCansel();
			g_bDraging = FALSE;
		}
		return;
	}

	//V[gJbgL[
	if (ProcessShortcutKey(hwnd, lpnkd->wVKey))
		return;
	if ((lpnkd->wVKey == 'M' && (GetKeyState(VK_CONTROL)&0x8000)) || (lpnkd->wVKey == VK_CONTROL && (GetKeyState(VK_MENU)&0x8000)))
	{
		HTREEITEM hItem = TreeView_GetSelection(m_hWnd);
		if (!hItem)
			OnRClick(0, 0);
		else
		{
			RECT rc;
			TreeView_GetItemRect(m_hWnd, hItem, &rc, TRUE);
			OnRClick(rc.left + (rc.right - rc.left) / 2, rc.top + (rc.bottom - rc.top) / 2);
		}
	}

	return;
}

///////////////////////////////////////////////////////////////
void CTreeView::OnSetFocus()
{
	g_MainWnd.m_CmdBands.SetEnableItemSelected2();
}

///////////////////////////////////////////////////////////////
void CTreeView::OnKillFocus()
{
	KillTimer(g_MainWnd.m_hWnd, ID_TIMER_TVSELECTED);
	if (m_bTimer)
	{
		SetCurrentFolder();
		m_bTimer = FALSE;
	}
}

///////////////////////////////////////////////////////////////
void CTreeView::OnSelChanged(NMTREEVIEW* lpnmtv)
{
	if (!m_bLoadReq) return;

	KillTimer(g_MainWnd.m_hWnd, ID_TIMER_TVSELECTED);
	if (lpnmtv->action == TVC_BYMOUSE)
		SetCurrentFolder();
	else
	{
		SetTimer(g_MainWnd.m_hWnd, ID_TIMER_TVSELECTED, TIMER_TVSELECTED_INT, NULL);
		m_bTimer = TRUE;
	}
}

///////////////////////////////////////////////////////////////
BOOL CTreeView::OnEndLabelEdit(TV_DISPINFO* pdi)
{
	TV_DISPINFO* pDispInfo = (TV_DISPINFO*)pdi;

	int nIndex = (int)pDispInfo->item.hItem;
	if (!pDispInfo->item.pszText) return FALSE;

	//G[`FbN
	if (_tcschr(pDispInfo->item.pszText, _T('\\')) != NULL
		|| _tcschr(pDispInfo->item.pszText, _T('/')) != NULL
		|| _tcschr(pDispInfo->item.pszText, _T(':')) != NULL
		|| _tcschr(pDispInfo->item.pszText, _T(',')) != NULL
		|| _tcschr(pDispInfo->item.pszText, _T(';')) != NULL
		|| _tcschr(pDispInfo->item.pszText, _T('*')) != NULL
		|| _tcschr(pDispInfo->item.pszText, _T('?')) != NULL
		|| _tcschr(pDispInfo->item.pszText, _T('<')) != NULL
		|| _tcschr(pDispInfo->item.pszText, _T('>')) != NULL
		|| _tcschr(pDispInfo->item.pszText, _T('|')) != NULL)
	{
		MessageBox(g_MainWnd.m_hWnd, GetResourceString(IDS_MSG_CANNOTUSECHAR), NULL, MB_OK|MB_ICONSTOP);
		SetFocus(m_hWnd);
		TreeView_EditLabel(m_hWnd, nIndex);
		return FALSE;
	}
	else
	{
		if (_tcslen(pDispInfo->item.pszText))
		{
			TCHAR szTempPath[MAX_PATH];
			_tcscpy(szTempPath, m_szCurrentFolder);
			LPTSTR lpszTemp = _tcsrchr(szTempPath, _T('\\'));
			if (lpszTemp)
			{
				*lpszTemp = 0;
				TCHAR szNewPath[MAX_PATH];
				TCHAR szOldPath[MAX_PATH];
				_stprintf(szOldPath, _T("%s"), m_szCurrentFolder);
				_stprintf(szNewPath, _T("%s\\%s"), szTempPath, pDispInfo->item.pszText);
				DisableUpdateNotify();
		
				//tH_ύX
				if (!MoveFile(szOldPath, szNewPath))
				{
					MessageBox(g_MainWnd.m_hWnd, GetResourceString(IDS_MSG_RENAMEERROR), NULL, MB_OK|MB_ICONSTOP);
					SetFocus(m_hWnd);
					TreeView_EditLabel(m_hWnd, nIndex);
					EnableUpdateNotify();
					return FALSE;
				}

				EnableUpdateNotify();
				
				//ύX̃pX֍XV
				_tcscat(szNewPath, _T("\\"));
				g_MainWnd.m_ListView.LoadFolderItem(szNewPath, FALSE);
			}
			else
			{
				//ۑpX(oȌꍇ̂ݔ)
				MessageBox(g_MainWnd.m_hWnd, GetResourceString(IDS_MSG_RENAMEERROR), NULL, MB_OK|MB_ICONSTOP);
				SetFocus(m_hWnd);
				TreeView_EditLabel(m_hWnd, nIndex);
				return FALSE;
			}
		}
		else
		{
			//s
			MessageBox(g_MainWnd.m_hWnd, GetResourceString(IDS_MSG_INPUTNAME), NULL, MB_OK|MB_ICONSTOP);
			SetFocus(m_hWnd);
			TreeView_EditLabel(m_hWnd, nIndex);
			return FALSE;
		}

	}

	return TRUE;
}
////////////////////////////////////////////////////////////////
void CTreeView::OnRClick(int cx, int cy, BOOL bSelect)
{
	HTREEITEM hItem = NULL;
	TVHITTESTINFO tv_ht;
	
	//IACe̎擾
	memset(&tv_ht, 0, sizeof(tv_ht));
	tv_ht.flags = TVHT_ONITEM;
	tv_ht.pt.x = cx;
	tv_ht.pt.y = cy;
	if (bSelect) ScreenToClient(m_hWnd, &(tv_ht.pt));
	hItem = TreeView_HitTest(m_hWnd, &tv_ht);

	//IACeȂꍇȂɂȂ
	if (!hItem)
		return;

	if (bSelect)
	{
		//ACẽnCCg
		TreeView_SelectItem(m_hWnd, hItem);
	}

	//ACẽx擾
	TCHAR szChildName[MAX_PATH] = _T("");
	TVITEM tvi;
	tvi.mask = TVIF_TEXT | TVIF_HANDLE;
	tvi.pszText = szChildName;
	tvi.cchTextMax = MAX_PATH;
	tvi.hItem = hItem;
	TreeView_GetItem(m_hWnd, &tvi);

	//tH_̏ꍇ
	if (IsSearchFolder(szChildName))
	{
		//j[͕\Ȃ
		return;
	}

	//ENbNj[쐬
	HMENU hMenu = GetSubMenu(g_MainWnd.m_ListView.m_hMenuPopup, ID_POPUP_FOLDERVIEW);
	UINT uEnable = g_MainWnd.m_ListView.m_nCount? (MF_BYCOMMAND|MF_ENABLED): (MF_BYCOMMAND|MF_GRAYED);
	EnableMenuItem(hMenu, ID_EDIT_PASTE, uEnable);
	uEnable = (_tcscmp(szChildName, GetRootName()) == 0)? (MF_BYCOMMAND|MF_GRAYED): (MF_BYCOMMAND|MF_ENABLED);
	EnableMenuItem(hMenu, ID_EDIT_CUT, uEnable);
	EnableMenuItem(hMenu, ID_EDIT_COPY, uEnable);

	//k/̗L/
	g_MainWnd.m_CmdBands.SetEnableCompressSelected(hMenu, hMenu, 0, 2, g_MainWnd.m_ListView.m_Settings.nCompDLL);

	//ENbNj[\
	TrackPopupMenu(hMenu, TPM_LEFTALIGN|TPM_TOPALIGN, cx, cy, 0, g_MainWnd.m_hWnd, NULL);
}

///////////////////////////////////////////////////////////////
// -- Ex.Q --
// c[ r[̍ڂ̐΃pX߂
void CTreeView::GetTree(HTREEITEM hItem, LPTSTR pszKey)
{
	TCHAR szName[MAX_PATH];

	TV_ITEM tvi;
	memset (&tvi, 0, sizeof (tvi));

	// e擾
	HTREEITEM hParent;
	hParent = TreeView_GetParent (m_hWnd, hItem);
	if (hParent)
	{ 
		// ڂ̐e̐eEEE擾
		GetTree(hParent, pszKey);

		// ڂ̖O擾
		tvi.mask       = TVIF_TEXT;
		tvi.hItem      = hItem;
		tvi.pszText    = szName;
		tvi.cchTextMax = MAX_PATH;
		TreeView_GetItem (m_hWnd, &tvi);

		// [głȂ΁
		if (_tcscmp(pszKey, GetRootName()) != 0)
			_tcscat(pszKey, _T("\\"));
		else
			_tcscpy(pszKey, _T("\\"));

		// ẽpXɍ̃tH_ǉ
		lstrcat (pszKey, szName);
	}
	else
	{
		//[g
		if (hItem == m_hRootItem)
		{
			// ڂ̖O擾
			_tcscpy(pszKey, GetRootName());
			szName[0]      = _T('\0');
			tvi.mask       = TVIF_TEXT | TVIF_PARAM;
			tvi.hItem      = hItem;
			tvi.pszText    = szName;
			tvi.cchTextMax = MAX_PATH;
			TreeView_GetItem (m_hWnd, &tvi);
		}
		//
		if (hItem == m_hSearchItem)
		{
			// ڂ̖O擾
			_tcscpy(pszKey, GetResourceString(IDS_SEARCH_FOLDER_NAME));
			szName[0]      = _T('\0');
			tvi.mask       = TVIF_TEXT | TVIF_PARAM;
			tvi.hItem      = hItem;
			tvi.pszText    = szName;
			tvi.cchTextMax = MAX_PATH;
			TreeView_GetItem (m_hWnd, &tvi);
		}
	}
}

///////////////////////////////////////////////////////////////
// CountChildren - L[̃TuL[̐𒲂ׂ
//
int CTreeView::CountChildren (LPTSTR pszPath, LPTSTR pszKey)
{
	int rc;
	TCHAR szName[MAX_PATH];
	HANDLE ff;
	WIN32_FIND_DATA wfd;
    DWORD dwCnt = 0;

	if (_tcscmp(pszPath, GetRootName()) != 0)
		wsprintf (szName, _T("%s\\%s\\*.*"), pszPath, pszKey);
	else
		wsprintf (szName, _T("\\%s\\*.*"), pszKey);

	ff = FindFirstFile( szName, &wfd );
	if (ff != INVALID_HANDLE_VALUE)
	{
		while (1)
		{
			if (_tcsicmp(wfd.cFileName, _T("Recycled")) != 0
				&& (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
			{
				dwCnt++;
				break;
			}
			rc = FindNextFile (ff, &wfd);
			if (rc == 0)
				break;
		}
		FindClose(ff);
    }
	return dwCnt;
}

///////////////////////////////////////////////////////////////
// EnumChildren - L[̃TuL[񋓂
int CTreeView::EnumChildren(HTREEITEM hParent, LPTSTR pszPath)
{
	int rc;
    DWORD nChild;
	HANDLE ff;
	WIN32_FIND_DATA wfd;
	TCHAR szName[MAX_PATH];
	TVINSERTSTRUCT tvis;
	DWORD dwCnt = 0;

	//tH_̏ꍇ
	if (IsSearchFolder(pszPath))
		return 0;

	//qm[h̑݃`FbN
	HTREEITEM hChild = TreeView_GetChild(m_hWnd, hParent);
	while (hChild)
	{
		//̃ACe擾
		HTREEITEM hNext = TreeView_GetNextItem(m_hWnd, hChild, TVGN_NEXT);

		//qm[h̃ACe擾
		TCHAR szChildName[MAX_PATH] = _T("");
		TVITEM tvi;
		tvi.mask = TVIF_TEXT | TVIF_HANDLE;
		tvi.pszText = szChildName;
		tvi.cchTextMax = MAX_PATH;
		tvi.hItem = hChild;
		TreeView_GetItem(m_hWnd, &tvi);

		if (_tcscmp(pszPath, GetRootName()) != 0)
			wsprintf (szName, _T("%s\\%s"), pszPath, szChildName);
		else
			wsprintf (szName, _T("\\%s"), szChildName);

		//݂Ȃꍇ
		if (GetFileAttributes(szName) == 0xFFFFFFFF)
			TreeView_DeleteItem(m_hWnd, hChild);
		hChild = hNext;

	}

	if (_tcscmp(pszPath, GetRootName()) != 0)
		wsprintf (szName, _T("%s\\*.*"), pszPath);
	else
		wsprintf (szName, _T("\\*.*"));

	ff = FindFirstFile (szName, &wfd);
	if (ff != INVALID_HANDLE_VALUE)
	{
		while (1)
		{
			if ((wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ||
				wfd.dwFileAttributes & FILE_ATTRIBUTE_TEMPORARY) &&
				_tcsicmp(wfd.cFileName, _T("Recycled")) != 0)
			{
				//qm[h̑݃`FbN
				BOOL bFind = FALSE;
				HTREEITEM hChild = TreeView_GetChild(m_hWnd, hParent);
				while (hChild)
				{
					//̃ACe擾
					HTREEITEM hNext = TreeView_GetNextItem(m_hWnd, hChild, TVGN_NEXT);

					//qm[h̃ACe擾
					TCHAR szChildName[MAX_PATH] = _T("");
					TVITEM tvi;
					tvi.mask = TVIF_TEXT | TVIF_HANDLE;
					tvi.pszText = szChildName;
					tvi.cchTextMax = MAX_PATH;
					tvi.hItem = hChild;
					TreeView_GetItem(m_hWnd, &tvi);

					if (_tcscmp(szChildName, wfd.cFileName) == 0)
					{
						bFind = !bFind;
						break;
					}
					hChild = hNext;

				}

				if (!bFind)
				{
					// ʂ̃fBNg邩
					nChild = CountChildren (pszPath, wfd.cFileName);

					// c[ r[ Rg[ɃL[}
					tvis.hParent      = hParent;
					tvis.hInsertAfter = TVI_SORT;
					tvis.item.mask    = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_CHILDREN;
					tvis.item.pszText = wfd.cFileName;
					tvis.item.cChildren = (nChild? 1: 0);
					
					if (_tcsicmp(wfd.cFileName, g_MainWnd.m_lpszStartMenu) == 0)
					{
						tvis.item.iImage = 5;
						tvis.item.iSelectedImage = 5;
					}
					else if (_tcsicmp(wfd.cFileName, g_MainWnd.m_lpszNetwork) == 0)
					{
						tvis.item.iImage = 6;
						tvis.item.iSelectedImage = 6;
					}
					else if (wfd.dwFileAttributes & FILE_ATTRIBUTE_TEMPORARY)
					{
						tvis.item.iImage = 3;
						tvis.item.iSelectedImage = 3;
					}
					else if (_tcsicmp(wfd.cFileName, g_MainWnd.m_lpszMyDocument) == 0)
					{
						tvis.item.iImage = 4;
						tvis.item.iSelectedImage = 4;
					}
					else
					{
						tvis.item.iImage = 1;
						tvis.item.iSelectedImage = 2;
					}

					TreeView_InsertItem(m_hWnd, &tvis);
				}
				dwCnt++;
			}
			rc = FindNextFile (ff, &wfd);
			if (rc == 0)
				break;
		}
		FindClose(ff);
	}

	// TuL[Ȃꍇ͓WJ{^폜
	TVITEM tvi;
	tvi.hItem = hParent;
	tvi.mask  = TVIF_CHILDREN;

	if (!TreeView_GetChild(m_hWnd, hParent))
		tvi.cChildren = 0;
	else
		tvi.cChildren = 1;
	TreeView_SetItem (m_hWnd, &tvi);

	// \[g
	TreeView_SortChildren(m_hWnd, hParent, 0);

	return dwCnt;
}

///////////////////////////////////////////////////////////////
void CTreeView::OnItemExpanded(NMTREEVIEW* lpnmtv)
{
	// Ƀu`WJƂɉ߂ė񋓂̂ŃTuL[폜
	if (lpnmtv->action == TVE_COLLAPSE)
	{
		//IĂm[hꍇ̃tH[JXړ
		if (lpnmtv->itemNew.hItem != lpnmtv->itemOld.hItem)
			SetCurrentFolder();
	}
}

///////////////////////////////////////////////////////////////
void CTreeView::OnItemExpanding(NMTREEVIEW* lpnmtv)
{
	if (lpnmtv->action == TVE_EXPAND)
	{
		TreeExpand(m_hWnd, lpnmtv->itemNew.hItem);
	}
}

///////////////////////////////////////////////////////////////
void CTreeView::OnMouseMove(POINT ptWnd)
{
	HWND hMain = g_MainWnd.m_hWnd;
	ClientToScreen(hMain, &ptWnd);

	//c[r[ɃnCCgݒ
	TVHITTESTINFO tv_ht ;
	memset(&tv_ht, 0, sizeof(tv_ht));
	tv_ht.flags = TVHT_ONITEM;
	tv_ht.pt.x = ptWnd.x;
	tv_ht.pt.y = ptWnd.y;
	ScreenToClient(m_hWnd, &(tv_ht.pt));
	
	HTREEITEM hItem = TreeView_HitTest(m_hWnd, &tv_ht);
	if (hItem)
	{
		//ACẽx擾
		TCHAR szChildName[MAX_PATH] = _T("");
		TVITEM tvi;
		tvi.mask = TVIF_TEXT | TVIF_HANDLE;
		tvi.pszText = szChildName;
		tvi.cchTextMax = MAX_PATH;
		tvi.hItem = hItem;
		TreeView_GetItem(m_hWnd, &tvi);

		//tH_ȊȌꍇ
		if (!IsSearchFolder(szChildName))
			TreeView_SelectDropTarget(m_hWnd, hItem);
		else
			TreeView_SelectDropTarget(m_hWnd, NULL);
	}
	else
		TreeView_SelectDropTarget(m_hWnd, NULL);
}

///////////////////////////////////////////////////////////////
BOOL CTreeView::OnLButtonUp(HWND hWnd)
{
	HWND hMain = g_MainWnd.m_hWnd;
	
	//c[r[̃hbv
	DWORD dwPos = GetMessagePos();
	TVHITTESTINFO tv_ht;
	memset(&tv_ht, 0, sizeof(tv_ht));
	tv_ht.flags = TVHT_ONITEM;
	tv_ht.pt.x = GET_X_LPARAM(dwPos);
	tv_ht.pt.y = GET_Y_LPARAM(dwPos);
	ScreenToClient(m_hWnd, &(tv_ht.pt));

	HTREEITEM hItem = TreeView_HitTest(m_hWnd, &tv_ht);
	if (hItem)
	{
		//ACẽx擾
		TCHAR szChildName[MAX_PATH] = _T("");
		TVITEM tvi;
		tvi.mask = TVIF_TEXT | TVIF_HANDLE;
		tvi.pszText = szChildName;
		tvi.cchTextMax = MAX_PATH;
		tvi.hItem = hItem;
		TreeView_GetItem(m_hWnd, &tvi);

		//tH_ȊȌꍇ
		if (!IsSearchFolder(szChildName))
		{
			OnDropEnter(hWnd, hItem);

			return TRUE;
		}
		else
			return FALSE;
	}
	else
		return FALSE;
}

///////////////////////////////////////////////////////////////
void CTreeView::OnDropEnter(HWND hWnd, HTREEITEM hItem)
{
	HWND hMain = g_MainWnd.m_hWnd;
	BOOL b_shortcut = FALSE;
	BOOL b_cut = FALSE;
	
	DWORD iMenuID=0;
	//ShiftL[̓j[\
	if (GetKeyState(VK_LSHIFT)&0x8000  ||
		GetKeyState(VK_RSHIFT)&0x8000 ||
		g_MainWnd.m_bShiftKey ||
		g_MainWnd.m_bContextMenu)
	{
		DWORD dwPos = GetMessagePos();
		POINT pt;
		pt.x = GET_X_LPARAM(dwPos);
		pt.y = GET_Y_LPARAM(dwPos);
		HMENU hMenu = GetSubMenu(g_MainWnd.m_ListView.m_hMenuPopup, ID_POPUP_DRAGDROP);
		iMenuID = TrackPopupMenu(hMenu, TPM_LEFTALIGN|TPM_TOPALIGN|TPM_RETURNCMD, pt.x, pt.y, 0, m_hWnd, NULL);		
		
		//j[I𖳂yуLZ̏ꍇ
		if (!iMenuID || iMenuID == ID_DROP_CANCEL)
		{
			//hbvACȅԂ
			TreeView_SelectDropTarget(m_hWnd, NULL);
			return;
		}
	}

	//hbvACȅԂ
	TreeView_SelectDropTarget(m_hWnd, NULL);

	//Rs[ȌԂ[ۑ
	TCHAR szFromFolder[MAX_PATH];
	GetCurrentFolder(szFromFolder);
	HTREEITEM hCurrent = TreeView_GetSelection(m_hWnd);

	//Rs[/؂/V[gJbg쐬s
	//Xgr[̃hbv
	if (hWnd != m_hWnd)
	{
		//1.Rs[̏ꍇ(+Ctl)
		if (iMenuID == ID_DROP_COPY ||
		   GetKeyState(VK_CONTROL)&0x8000 ||
		   g_MainWnd.m_bControlKey)
		{
			g_MainWnd.m_ListView.OnEditCopy();
			
		//2.V[gJbg쐬(+Alt)̏ꍇ
		}
		else if (iMenuID == ID_DROP_SHORTCUT ||
			      GetKeyState(VK_MENU)&0x8000)
		{
			g_MainWnd.m_ListView.OnEditCopy();
			b_shortcut = TRUE;

		//3.؂̏ꍇ
		}
		else
		{
			g_MainWnd.m_ListView.OnEditCut();
		}
	}
	//c[r[̃hbv
	else
	{
		//hbOACeI
		TreeView_SelectItem(m_hWnd, g_MainWnd.m_hDragTree);

		//1.Rs[̏ꍇ(+Ctl)
		if (iMenuID == ID_DROP_COPY ||
		   GetKeyState(VK_CONTROL)&0x8000 ||
		   g_MainWnd.m_bControlKey)
		{
			OnEditCopy();
			
		//2.V[gJbg쐬(+Alt)̏ꍇ
		}
		else if (iMenuID == ID_DROP_SHORTCUT ||
				  GetKeyState(VK_MENU)&0x8000)
		{
			OnEditCopy();
			b_shortcut = TRUE;

		//3.؂̏ꍇ
		}
		else
		{
			OnEditCut();
			b_cut = TRUE;
		}
	}

	//hbvACeI
	TreeView_SelectItem(m_hWnd, hItem);
	GetCurrentFolder(g_MainWnd.m_ListView.m_szCurrentFolder);

	//\ts
	if (iMenuID != ID_DROP_CANCEL)
	{
		if (b_shortcut)
		{
			g_MainWnd.m_ListView.OnEditPasteShortcut(FALSE);
		}
		else
		{
			g_MainWnd.m_ListView.OnEditPaste(FALSE);
		}
	}

	//\tÕfBNgȂꍇAʃfBNgֈړ
	while (GetFileAttributes(szFromFolder) == 0xFFFFFFFF)
	{
		LPTSTR lpszTemp = _tcsrchr(szFromFolder, _T('\\'));
		if (lpszTemp)
			*lpszTemp = _T('\0');
		else
			break;
	} // End of while

	//\tȌԂ֖߂
	g_MainWnd.m_ListView.LoadFolderItem(szFromFolder, FALSE);
}

///////////////////////////////////////////////////////////////
void CTreeView::OnDropCansel()
{
	//hbvI
	TreeView_SelectDropTarget(m_hWnd, NULL);
}

///////////////////////////////////////////////////////////////
void CTreeView::OnViewUpFolder()
{
	if (IsSearchFolder(g_MainWnd.m_ListView.m_szCurrentFolder))
	{
		*g_MainWnd.m_ListView.m_szOldFolder = _T('\0');
		g_MainWnd.m_ListView.LoadFolderItem(_T(""));
	}
	else
	{
		//݂̃ACe擾
		HTREEITEM hTreeItem = TreeView_GetSelection(m_hWnd);
		if (hTreeItem)
		{
			//̃ACe擾
			hTreeItem = TreeView_GetParent(m_hWnd, hTreeItem);

			if (hTreeItem)
				//ACẽnCCg
				TreeView_SelectItem(m_hWnd, hTreeItem);
		}

		//Xgr[̍XV
		SetCurrentFolder();
	}
}

///////////////////////////////////////////////////////////////
void CTreeView::OnEditCopy()
{
	//݂̃fBNgACeƂđI
	TCHAR szPath[MAX_PATH];
	GetCurrentFolder(szPath);
	g_MainWnd.m_ListView.SelectFile(szPath);

	//Rs[s
	WCHAR szFromPath[MAX_PATH], *ptr;
	_tcscpy(szFromPath, szPath);
	if (ptr = _tcsrchr(szFromPath, _T('\\')))	//tH_\ł́uRs[tH_v́AJgtH_1Kww
		*ptr = _T('\0');
	g_MainWnd.m_ListView.OnEditCopy(szFromPath);

	//̃fBNg֖߂
	g_MainWnd.m_ListView.LoadFolderItem(szPath, FALSE);
}

///////////////////////////////////////////////////////////////
void CTreeView::OnEditCut()
{
	//݂̃fBNgACeƂđI
	TCHAR szPath[MAX_PATH];
	GetCurrentFolder(szPath);
	g_MainWnd.m_ListView.SelectFile(szPath);

	//؂菈s
	WCHAR szFromPath[MAX_PATH], *ptr;
	_tcscpy(szFromPath, szPath);
	if (ptr = _tcsrchr(szFromPath, _T('\\')))	//tH_\ł́uRs[tH_v́AJgtH_1Kww
		*ptr = _T('\0');
	g_MainWnd.m_ListView.OnEditCut(szFromPath);

	//̃fBNg֖߂
	g_MainWnd.m_ListView.LoadFolderItem(szPath, FALSE);
}

///////////////////////////////////////////////////////////////
void CTreeView::OnFileDelete()
{
	//݂̃fBNgACeƂđI
	TCHAR szPath[MAX_PATH];
	GetCurrentFolder(szPath);
	g_MainWnd.m_ListView.SelectFile(szPath);

	//폜s
	g_MainWnd.m_ListView.OnFileDelete();

	//\tÕfBNgȂꍇAʃfBNgֈړ
	while (GetFileAttributes(szPath) == 0xFFFFFFFF)
	{
		LPTSTR lpszTemp = _tcsrchr(szPath, _T('\\'));
		if (lpszTemp)
			*lpszTemp = 0;
		else
			break;
	} // End of while

	//̃fBNg֖߂
	g_MainWnd.m_ListView.LoadFolderItem(szPath, FALSE);
}

///////////////////////////////////////////////////////////////
void CTreeView::OnFileRename()
{
	//݂̑IACe擾
	HTREEITEM hItem = TreeView_GetSelection(m_hWnd);
	if (hItem)
	{
		//xҏWԂɂ
		SetFocus(m_hWnd);
		TreeView_EditLabel(m_hWnd, hItem);
	}
}

///////////////////////////////////////////////////////////////
void CTreeView::OnFileCreateShortcut()
{
	//݂̃fBNgACeƂđI
	TCHAR szPath[MAX_PATH];
	GetCurrentFolder(szPath);
	g_MainWnd.m_ListView.SelectFile(szPath);

	//V[gJbg쐬s
	g_MainWnd.m_ListView.OnFileCreateShortcut();

	//̃fBNg֖߂
	g_MainWnd.m_ListView.LoadFolderItem(szPath, FALSE);
}

///////////////////////////////////////////////////////////////
void CTreeView::OnFileProperty()
{
	//݂̃fBNgACeƂđI
	TCHAR szPath[MAX_PATH];
	GetCurrentFolder(szPath);
	g_MainWnd.m_ListView.SelectFile(szPath);

	//vpeBs
	g_MainWnd.m_ListView.OnFileProperty();

	//̃fBNg֖߂
	g_MainWnd.m_ListView.LoadFolderItem(szPath, FALSE);
}

///////////////////////////////////////////////////////////////
void CTreeView::OnFileShortcutFolder()
{
	//݂̃fBNgACeƂđI
	TCHAR szPath[MAX_PATH];
	GetCurrentFolder(szPath);
	g_MainWnd.m_ListView.SelectFile(szPath);

	//V[gJbg𑗂鏈s
	g_MainWnd.m_ListView.OnFileShortcutFolder();

	//̃fBNg֖߂
	g_MainWnd.m_ListView.LoadFolderItem(szPath, FALSE);
}

///////////////////////////////////////////////////////////////
void CTreeView::OnFileCopyFolder()
{
	//݂̃fBNgACeƂđI
	TCHAR szPath[MAX_PATH];
	GetCurrentFolder(szPath);
	g_MainWnd.m_ListView.SelectFile(szPath);

	//t@CtH_փRs[s
	g_MainWnd.m_ListView.OnFileCopyFolder();

	//̃fBNg֖߂
	g_MainWnd.m_ListView.LoadFolderItem(szPath, FALSE);
}

///////////////////////////////////////////////////////////////
void CTreeView::OnFileMoveFolder()
{
	//݂̃fBNgACeƂđI
	TCHAR szPath[MAX_PATH];
	GetCurrentFolder(szPath);
	g_MainWnd.m_ListView.SelectFile(szPath);

	//t@CtH_ֈړs
	g_MainWnd.m_ListView.OnFileMoveFolder();

	//\tÕfBNgȂꍇAʃfBNgֈړ
	while (GetFileAttributes(szPath) == 0xFFFFFFFF)
	{
		LPTSTR lpszTemp = _tcsrchr(szPath, _T('\\'));
		if (lpszTemp)
			*lpszTemp = 0;
		else
			break;
	} // End of while

	//̃fBNg֖߂
	g_MainWnd.m_ListView.LoadFolderItem(szPath, FALSE);
}

///////////////////////////////////////////////////////////////
void CTreeView::OnEditCopyFileName()
{
	//݂̃fBNgACeƂđI
	TCHAR szPath[MAX_PATH];
	GetCurrentFolder(szPath);
	g_MainWnd.m_ListView.SelectFile(szPath);

	//ORs[s
	g_MainWnd.m_ListView.OnEditCopyFileName();

	//̃fBNg֖߂
	g_MainWnd.m_ListView.LoadFolderItem(szPath, FALSE);
}

///////////////////////////////////////////////////////////////
void CTreeView::OnEditCopyFilePath()
{
	//݂̃fBNgACeƂđI
	TCHAR szPath[MAX_PATH];
	GetCurrentFolder(szPath);
	g_MainWnd.m_ListView.SelectFile(szPath);

	//ORs[s
	g_MainWnd.m_ListView.OnEditCopyFilePath();

	//̃fBNg֖߂
	g_MainWnd.m_ListView.LoadFolderItem(szPath, FALSE);
}

///////////////////////////////////////////////////////////////
BOOL CTreeView::OnFileCompress()
{
	//݂̃fBNgACeƂđI
	TCHAR szPath[MAX_PATH];
	GetCurrentFolder(szPath);
	g_MainWnd.m_ListView.SelectFile(szPath);

	//ks
	BOOL bRtn = g_MainWnd.m_ListView.OnFileCompress();

	//̃fBNg֖߂
	if (!(g_MainWnd.m_ListView.m_Settings.bMoveDir || 
		g_MainWnd.m_ListView.m_Settings.bAutoUnComp))
	{
		//̃fBNg֖߂
		g_MainWnd.m_ListView.LoadFolderItem(szPath, FALSE);
	}

	return bRtn;
}

///////////////////////////////////////////////////////////////
void CTreeView::OnFavoritesAdd()
{
	//݂̃fBNgACeƂđI
	TCHAR szPath[MAX_PATH];
	GetCurrentFolder(szPath);
	g_MainWnd.m_ListView.SelectFile(szPath);

	//Rs[s
	g_MainWnd.m_ListView.OnEditCopy();

	//Cɓ̃fBNgֈړ
	_tcscpy(g_MainWnd.m_ListView.m_szCurrentFolder, g_MainWnd.m_szFavoritesPath);

	//V[gJbg̓\t(ݒɊ֌WȂ"`ւ̃V[gJbg"͕tȂ)
	BOOL bTemp = g_MainWnd.m_ListView.m_Settings.bNotShortcutName;
	g_MainWnd.m_ListView.m_Settings.bNotShortcutName = TRUE;
	g_MainWnd.m_ListView.OnEditPasteShortcut(FALSE);
	g_MainWnd.m_ListView.m_Settings.bNotShortcutName = bTemp;

	//̃fBNg֖߂
	g_MainWnd.m_ListView.LoadFolderItem(szPath, FALSE);

	//Cɓ胁j[̍č쐬
	g_MainWnd.m_ListView.InitFavoritesMenu();
}

///////////////////////////////////////////////////////////////
void CTreeView::OnTapAndHold()
{
	DWORD dwPos = GetMessagePos();
	OnRClick(GET_X_LPARAM(dwPos), GET_Y_LPARAM(dwPos), TRUE);
}

///////////////////////////////////////////////////////////////
void CTreeView::OnTapAndHold(NMRGINFO* pnmri)
{
	OnRClick(pnmri->ptAction.x, pnmri->ptAction.y, TRUE);
}

///////////////////////////////////////////////////////////////
void CTreeView::OnTapHoldBegin(DWORD dwPos)
{
	SetFocus(m_hWnd);
}
